**
** BPPCFix_kickcode.asm
**
** Disables ppc.library resident modules on Amigas with BPPC
** Written in 1998 by Frank Wille <frank@phoenix.owl.de>
**
** V1.0  26-Dec-98
**       created

	include	"exec/execbase.i"
	include	"exec/resident.i"

	section	CODE,code


	xdef	_BPPCFixCode
_BPPCFixCode:
	movem.l	a2-a3,-(sp)
	move.l	ResModules(a6),a0
	move.l	a0,a1
	bra	loop_end
loop:
	move.l	d0,(a1)+
	bpl	1$
	bclr	#31,d0
	move.l	d0,a0
	move.l	d0,a1
	bra	loop_end
1$:	move.l	d0,a2

; compare module name with "ppc.library"
	move.l	RT_NAME(a2),a2		; name of current module
	lea	ppc_name(pc),a3
	moveq	#12-1,d0
2$:	cmpm.b	(a2)+,(a3)+
	dbne	d0,2$
	bne	loop_end
	subq.l	#4,a1			; ppc.library found - remove module

loop_end:
	move.l	(a0)+,d0
	bne	loop
	clr.l	(a1)
	jsr	-636(a6)		; CacheClearU()
	movem.l	(sp)+,a2-a3
	rts

ppc_name:
	dc.b	"ppc.library",0
	cnop	0,4

	xdef	_BPPCFixCode_end
_BPPCFixCode_end:
