/*
 * kicktags.h
 * Based on "KickTags.h" by Ralph Babel 1988.
 * vbcc-apdation, written by Frank Wille 1998.
 *
 */
#ifndef KICKTAGS_H
#define KICKTAGS_H

#ifndef EXEC_EXECBASE_H
#include <exec/execbase.h>
#endif

#ifndef EXEC_MEMORY_H
#include <exec/memory.h>
#endif

#ifndef EXEC_RESIDENT_H
#include <exec/resident.h>
#endif


struct KickTagHeader {
  struct MemChunk MemChunk;
  APTR KickTagArray[2];
  struct Resident Resident;
  struct MemList MemList;
};


void *AllocKickMem(struct ExecBase *,ULONG,ULONG,LONG);
struct KickTagHeader *FindKickTag(struct ExecBase *,const char *,ULONG);
void AddKickTag(struct ExecBase *,struct KickTagHeader *,ULONG,UWORD);
struct KickTagHeader *RemKickTag(struct ExecBase *,const char *,ULONG);
void clearCache(struct ExecBase *);

#endif
